`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company:				jc-21.ac Japan
// Engineer:			Takeshi Sakato
// 
// Create Date:		16:48:16 02/12/2012 
// Design Name:		
// Module Name:		Disp_Counter
// Project Name:		RangFinderForRs232
// Target Devices:	Xilinx Spartan3E
// Tool versions:		ISE 8.2i
// Description: 
// (Lq)
//
// Dependencies: 
// (ˑ)
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Disp_Counter(SelCLK, Count_Data, Seg_Data, Sel);
	input SelCLK;
	input [15:0]Count_Data;
	output [8:1]Seg_Data;
	output [4:1]Sel;

	reg [4:1]com_select = 4'b1110;

	function [3:0]col ;
	input [3:0]sel_data ;
		case (sel_data)
			4'b1110:	col = Count_Data[3:0] ;
			4'b1101:	col = Count_Data[7:4] ;
			4'b1011:	col = Count_Data[11:8] ;
			4'b0111:	col = Count_Data[15:12] ;
		endcase
	endfunction

	function [7:0]dec ;
	input [3:0]in_data ;
		case (in_data)
			4'b0000:	dec = 8'b00111111 ;	// 0
			4'b0001:	dec = 8'b00000110 ;	// 1.
			4'b0010:	dec = 8'b01011011 ;	// 2
			4'b0011:	dec = 8'b01001111 ;	// 3.
			4'b0100:	dec = 8'b01100110 ;	// 4
			4'b0101:	dec = 8'b01101101 ;	// 5.
			4'b0110:	dec = 8'b01111101 ;	// 6
			4'b0111:	dec = 8'b00100111 ;	// 7.
			4'b1000:	dec = 8'b01111111 ;	// 8
			4'b1001:	dec = 8'b01100111 ;	// 9.
			4'b1010:	dec = 8'b01110111 ;	// A.
			4'b1011:	dec = 8'b01111100 ;	// b.
			4'b1100:	dec = 8'b00111001 ;	// C.
			4'b1101:	dec = 8'b01011110 ;	// d.
			4'b1110:	dec = 8'b01111001 ;	// E.
			4'b1111:	dec = 8'b01110001 ;	// F.
		endcase
	endfunction

	assign Sel = com_select;
	assign Seg_Data = ~dec(col(com_select[4:1])) ;

	always @(posedge SelCLK)begin
			com_select[2] <= com_select[1];
			com_select[3] <= com_select[2];
			com_select[4] <= com_select[3];
			com_select[1] <= com_select[4];
	end
endmodule
