////////////////////////////////////////////
// 				SPI CLOCK GEN					//
//		2013 edition by Mikata Masahito		//
// 	Module Name:    clk8m_gen 				//
//		Instance Name:  U10						//
////////////////////////////////////////////
// 			Revision record
// 	ver 1.0 New RTL 2014.02.06

module clk8m_gen(GCLK, clk8m);

input GCLK;					//Global Clock 33.333MHz
output clk8m;				//SCK Source

// 33.33MHz/4=8.33MHz

parameter spirate0 = 3;	//4count clock = 0
parameter spirate1 = 1;	//2count clock = 1
 
reg  [3:0]sckcou;			//Global Clock counter
reg  sckflg;				//SCK Pulse

//GCLK Divide 4

always @(posedge GCLK)
begin
	if(sckcou == spirate0) begin	// 1/4GCLK
		sckcou <= 0;
		sckflg <= 0;					//SCK = 0
	end

	else begin
		if(sckcou == spirate1) begin	// 1/2GCLK
			sckcou <= sckcou + 1; 
			sckflg <= 1;					//SCK = 1
		end

		else begin		
			sckcou <= sckcou + 1;
		end
	end
end

//SCK GEN assign

assign clk8m = sckflg;

endmodule
