`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company:			jc-21.ac Japan
// Engineer:		Takeshi Sakato
// 
// Create Date:		00:29:29 12/16/2012 
// Design Name:		RS232C_CLKGEN
// Module Name:		RS232C_CLKGEN 
// Project Name:		RangFinderForRs232
// Target Devices:	Xilinx Spartan3E
// Tool versions:		ISE 8.2i
// Description: 
// (Lq)
//
// Dependencies: 
// (ˑ)
//
// Revision:			0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
/***                 */
/**  RS232C_CLKGEN  **/
/*                 ***/
module RS232C_CLKGEN( CK, RST, TX_CK, RX_CK );
input  CK;
input  RST;
output TX_CK;
output RX_CK;

// ްڰėpۯĒl
parameter bps110   = 303027;
parameter bps150   = 222220;
parameter bps300   = 111110;
parameter bps1200  =  27777;
parameter bps2400  =  13888;
parameter bps4800  =   6944;
parameter bps9600  =   3472;
parameter bps19200 =   1736;
//parameter bps38400 =    868;
parameter bps38400 =    434;

parameter bps = bps38400;

reg [19:0] TX_CNT;
reg [19:0] RX_CNT;
reg RX_FLG;
reg TX_FLG;

always @( posedge CK )
begin
	if( RST ) begin
		RX_CNT <= 0;
		RX_FLG <= 0;
		TX_CNT <= 0;
		TX_FLG <= 0;
	end
	else begin
		if( RX_CNT == ( bps / 16 ) ) begin	// TX_CNT -> 1/16
			RX_CNT <= 0;
			RX_FLG <= 1;
		end
		else begin
			RX_CNT <= RX_CNT + 1;
			RX_FLG <= 0;
		end
		if( TX_CNT == bps ) begin	// 38400bps
			TX_CNT <= 0;
//			TX_FLG <= 1;
			TX_FLG <= TX_FLG ^ 1;
		end
		else begin
			TX_CNT <= TX_CNT + 1;
//			TX_FLG <= 0;
		end
	end
end

assign RX_CK = RX_FLG;
assign TX_CK = TX_FLG;

endmodule

