`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company:				jc-21.ac Japan
// Engineer:			Takeshi Sakato
// 
// Create Date:		00:29:29 12/16/2012 
// Design Name:		RS232C_TX
// Module Name:		RS232C_TX 
// Project Name:		RangFinderForRs232
// Target Devices:	Xilinx Spartan3E
// Tool versions:		ISE 8.2i
// Description: 
// (Lq)
//
// Dependencies: 
// (ˑ)
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
/***                  */
/**    RS232C_TX     **/
/*   d8 pn s1 xoff  ***/
module RS232C_TX( TX_CK, RST, TX_EN, WR, PD_IN, SD_OUT ) ;
	input  TX_CK;
	input  RST;
	input  TX_EN;
	input  WR;
	input  [7:0] PD_IN;	// ް
	output SD_OUT;			// رްo

	reg    SD_OUT;

	reg    LOAD;
	reg    [7:0] SERIAL;
	reg    [3:0] CBIT;

	always @( posedge TX_CK ) begin
		if( RST ) begin
			SD_OUT <= 1'b1;
			CBIT <= 4'h0;
			LOAD  <= 1'b0;
		end
		else begin
			if( WR ) begin
				LOAD   <= 1'b1;
				SERIAL <= PD_IN;
			end
			else begin
				if( TX_EN && LOAD ) begin
					case( CBIT )
						// ޯĂ̑o(0)
						0 : 
						begin
							SD_OUT <= 1'b0;
							CBIT <= CBIT + 4'h1;
						end

						// ްޯĂ̑o
						1,2,3,4,5,6,7,8 :
						begin
							SD_OUT   <= SERIAL[0];
							SERIAL <= { 1'b1, SERIAL[7:1]};
							CBIT   <= CBIT + 4'h1;
						end
						// įޯĂ̑o(1bit)
						9 :
						begin
							SD_OUT  <= 1'b1;
							CBIT   <= CBIT + 4'h1;
//							LOAD  <= 1'b0;
						end
//	įޯĂ 1 ޯĂ̏ꍇȉ
///////////////////////////////////////////
//						// įޯĂ̑o(2bit)
						10 :
						begin
							SD_OUT  <= 1'b1;
							CBIT  <= 4'h0;
							LOAD  <= 1'b0;
						end
///////////////////////////////////////////
						default :
						begin
							SD_OUT <= 1'b1;
							CBIT <= 4'h0;
						end
					endcase
				end	//	if (TX_EN && LOAD)
			end	//end else (WR)
		end	// end else (RST)
	end	// end always

endmodule


