`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: jc-21
// Engineer: Takeshi Sakato
// 
// Create Date:    15:34:57 06/17/2010 
// Design Name: 	 Servo Motor Control
// Module Name:    gen_180k_clk 
// Project Name: 	 Servo2
// Target Devices: xc3s100e-5vq
// Tool versions:  ISE 8.2i
// Description: 	 Pulse Generator 180kHz Clock
// ij
// Dependencies: 	 Base Clock 33.333MHz
// iˑj
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
//*****************************************************************************//
//////******** ]W[ ********/////////////////////////////////////////////
//////******** 180KHz CLOCK GENERATOR ********///////////////////////////////////
//*****************************************************************************//
module gen_180k_clk(base_clk, p180k_clk);
input		base_clk ;
output	p180k_clk ;

	reg [7:0]count_clk ;
	reg flg_180k = 1'b0 ;

	always @(posedge base_clk)
	begin
	/////@180kHzJEgtOݒ@/////
		if ( count_clk == 8'h5C )begin
			count_clk <= 8'h00 ;
			flg_180k <= flg_180k ^ 1'b1 ;
		end
		else begin
			count_clk <= count_clk + 1 ;
		end
	end
	assign p180k_clk = flg_180k ;
endmodule
