`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: jc-21
// Engineer: Takeshi Sakato
// 
// Create Date:    15:36:24 06/17/2010 
// Design Name: 	 Servo Motor Control
// Module Name:    gen_1s_clk 
// Project Name: 	 Servo2
// Target Devices: xc3s100e-5vq
// Tool versions:  ISE 8.2i
// Description: 	 Pulse Generator 1Hz Clock
// ij
// Dependencies: 	 Base Clock 180kHz
// iˑj
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
///*****************************************************************************//
//////******** ]W[ ********/////////////////////////////////////////////
//////******** 1Hz CLOCK GENERATOR ********//////////////////////////////////////
//*****************************************************************************//
module gen_1_clk(base_clk, p1s_clk);
input		base_clk ;
output	p1s_clk ;

	reg [19:0]count_clk ;
	reg flg_1s = 1'b0 ;

	always @(posedge base_clk)
	begin
	/////@K莞(1b)JEgtOݒ@/////
		if ( count_clk == 20'h02FC8 )begin	//0.5sec
//		if ( count_clk == 20'h15F90 )begin	//1sec
			count_clk <= 20'h00000 ;
			flg_1s <= flg_1s ^ 1'b1 ;
		end
		else begin
			count_clk <= count_clk + 1 ;
		end
	end
	assign p1s_clk = flg_1s ;
endmodule
